/*

The Life of a Geek
Copyright (C) 2003-2004 Daniel Quintiliani

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

You can e-mail Daniel Quintiliani at coredump0@mercurylink.net

main.cc - Main program.

3/16/04: Daniel Quintiliani <coredump0@mercurylink.net>: Added save & load game
 code.
2/3/04: Daniel Quintiliani <coredump0@mercurylink.net>: Updated e-mail address,
added scoring code, updated copyright.
7/4/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated code for new
readfromfilevars(), fixed bug where gpl check wouldn't be done in certain
spots, moved virus deduction/healing code into func.cc DeductVirAndHeal(),
fixed pause doing a newline after falling asleep.
6/14/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed support for
older compilers/C libraries.
6/13/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Added elapsed time
code, updated handling of geek's name, made virus point deduction more random,
if you run out of energy and fall asleep, the screen pauses.
5/21/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Updated virus point
deduction code.
5/20/03: Daniel Quintiliani <coredump@coredumpcentral.org>: main.lg used now
instead of game.lg.
4/24/03: Daniel Quintiliani <coredump@coredumpcentral.org>: Fixed a bug where
you would be stuck if you had no energy and no money instead of falling asleep.
Text file game.lg now used.
4/7/03: Daniel Quintiliani <coredump@coredumpcentral.org>:
gpl_check_and_strlwr() put in, now you can enter name of geek,
to be more considerate replaced all bools with ints, added
object of game into game.
 
*/

#include "func.h"
#include <iostream>
#include "display.h"

using namespace std;

int main()
{
	string s = "show w", s2 = "show w";
	Computer comp;
	Geek geek;
	ElTime elt;
	
	cout << readfromfilevars(MAINFILE,"!INTRO",0,geek,comp,comp,elt,0,0,"","","");	

	int newgame = LoadGame(geek,comp,elt);

	if(newgame == -1)
	{
		while(s2 == "show w" || s2 == "show c" )
		{
			cout << readfromfile(MAINFILE,"!PNAME",1);
			getline(cin, s2);
			string geekname;
			geekname = s2.c_str();
			gpl_check_and_strlwr(s2);
			if(geekname=="")
				geek.SetName("Geek");
			else
				geek.SetName(geekname.c_str());
			cout << endl;
		}
	}
	else
		cout << "Previously saved game loaded.\n" << endl;
	
	while(s[0] != 'i')
	{
		cout << readfromfile(MAINFILE,"!MAINMENU",0);	

		while(s == "show w" || s == "show c" )
		{
			cout << readfromfile(MAINFILE,"!PENTER",1);
			getline(cin, s);
			gpl_check_and_strlwr(s);
			cout << endl;
		}
			
		if(s[0] == 'a')	
			ShowStats(geek, comp,elt);
		else if(s[0] == 'b')
			SpeedClass(geek, comp,elt);
		else if(s[0] == 'c')	
			Work(geek, comp,elt);
		else if(s[0] == 'd')	
			Caff(geek,elt);
		else if(s[0] == 'e')	
		{
			if(Hack(geek,comp,elt)==-1)
			{
				cout << "Your score was " << 
				CalculateScore(geek,comp,elt) << endl;
				InsertScore(geek,comp,elt);
				DisplayScores();
				return 0;
			}
		}
		else if(s[0] == 'f')	
			AntiVirus(geek, comp,elt);
		else if(s[0] == 'g')	
			WasteTime(geek,comp,elt);
		else if(s[0] == 'h')	
			Sleep(geek, comp,elt);
		else if(s[0] == 'i')	
		{
		        SaveGame(geek,comp,elt);	
			cout << "Your game has been saved." << endl;
		}
		
		if(s[0] != 'i')
		{
			if( DeductVirAndHeal(comp,elt,0) == -1 )
				return 0;	
			
			if( geek.GetEnergy() <= 0 )
			{
				string stemp;
				cout << readfromfile(MAINFILE,"!FALLASLP",0);

				cout << readfromfile(MAINFILE,"!PAUSE",1);
				getline(cin,stemp);
				gpl_check_and_strlwr(stemp);
				CmdSleep(geek,comp,elt);
			}
			if(comp.GetHealth() == comp.GetMaxHealth() && comp.GetInfected() != 0 && geek.GetEducation() >= 40 )
			{
				cout << readfromfile(MAINFILE,"!WINNER",0);
				int Score = CalculateScore(geek,comp,elt)
					* 10^3;
				cout << "Your score was " << Score << endl;
				InsertScore(geek,comp,elt);
				DisplayScores();
				return 0;
			}
			
			s = "show w";
		
		}		
	}
	
	return 0;
}
